$APPTYPE GUI
$TYPECHECK ON

$INCLUDE "RAPIDQ.INC"

DECLARE SUB Envoie (Send AS QBUTTON)
DECLARE SUB TimerExpired
DECLARE SUB Reconnect
DECLARE SUB Serveur_Starting

CONST DELAY = 500
CONST PortNum = 80

DIM Le_Socket AS QSocket
DIM Timer_X AS QTimer
DIM MasterSocket AS INTEGER
DIM NumClients AS INTEGER
DIM Client(1 TO 50) AS INTEGER
DIM SwearCount AS INTEGER
DIM Swears(1 TO 50) AS STRING
    Swears(1) = "ASS"
    Swears(2) = "BASTARD"
    Swears(3) = "HELL"
    SwearCount = 3
DIM Serveur AS INTEGER
DIM Font AS QFONT
Font.Color = &H00FF00
Font.AddStyles(fsBold)
Font.Size = 10
DIM Etat AS INTEGER
Etat = 0
DIM Socket AS QSOCKET
DIM SockNum AS INTEGER
SockNum = 0
DIM Timer1 AS QTIMER
Timer1.Interval = DELAY
Timer1.OnTimer = TimerExpired

CREATE Main_Form AS QFORM
    Caption = "Cindy System - Version de Dveloppement -"
    Width = 505
    Height = 505
    Color = 0
    BorderStyle = 4
    WindowState = wsNormal
    Center
    CREATE Conversation_Edit AS QEDIT
        Font = Font
        Font.Name = "Courier New"
        Color = &H000000
        Left = 5
        Top = 215
        Width = 490
        Text = "Tapez votre Message ici..."
    END CREATE
    CREATE Etat_Label AS QLABEL
        LabelStyle = 2
        Top = 250
        Caption = "Connect au Systme..."
        Left = 330
        Font = Font
        Font.Color = &H0000FF
    END CREATE
    CREATE Send_Button AS QBUTTON
        Caption = "Soumettre"
        Left = 5
        Top = 247
        TabOrder = 10
        Default = True
        Font.AddStyles(fsBold)
        OnClick = Envoie
    END CREATE
    CREATE Message_Socket AS QRICHEDIT
        Color = 0
        Font = Font
        Font.Name = "Courier"
        Font.Size = 10
        Alignment = 0
        BorderStyle = 1
        ScrollBars = 2
        Left = 5
        Top = 280
        Width = 490
        Height = 195
        ReadOnly = 1
    END CREATE
    CREATE Cindy_Socket AS QRICHEDIT
        Color = 0
        Font = Font
        Font.Name = "Courier"
        Font.Size = 10
        Alignment = 0
        BorderStyle = 1
        ScrollBars = 2
        Left = 5
        Top = 10
        Width = 490
        Height = 195
        ReadOnly = 1
    END CREATE
END CREATE

SUB Envoie(Send AS QBUTTON)
    IF LEN(Conversation_Edit.Text) <= 0 THEN
        Conversation_Edit.Text = "{Anti-Bug System}"
    END IF
    IF SockNum <= 0 THEN
        Etat = 0
        MessageBox("Le Serveur Cindy est Dconnect !!", "Socket Error !!", 0)
        Cindy_Socket.Clear
        Message_Socket.Clear
        Reconnect
    ELSE
        IF Socket.WriteLine(SockNum, Conversation_Edit.Text) = -1 THEN
            Etat = 0
            MessageBox("Cindy vous as Dconnect !!", "Socket Error !!", 0)
            Cindy_Socket.Clear
            Message_Socket.Clear
            Reconnect
        END IF
    END IF
    Message_Socket.AddString "User> " + Conversation_Edit.Text
    Conversation_Edit.Text = ""
END SUB    

SUB Reconnect
  MessageBox("Tentative de Reconnexion en cour...", "Socket Connect !!", 0)
  Etat_Label.Caption = "Reconnexion en cour..."
  IF Etat = 0 THEN
    Timer1.Enabled = False
    Socket.Close(SockNum)
    SockNum = 0
    Timer1.Enabled = True
  END IF
  SockNum = Socket.Connect("127.0.0.1", 35)
  IF SockNum > 0 THEN
    Etat = 1
    MessageBox("Connexion Etablie !!", "Socket Connect !!", 0)
    Etat_Label.Caption = "Connect au Systme..."
    Etat_Label.Left = 330
  ELSE
    SockNum = 0
  END IF
  Etat_Label.Caption = "Dconnect du Systme..."
  Etat_Label.Left = 310
END SUB

SUB TimerExpired
  Timer1.Enabled = False
  Timer1.Interval = DELAY
  IF SockNum <= 0 THEN
    Timer1.Enabled = True
    EXIT SUB
  END IF
  IF Socket.IsServerReady(SockNum) THEN
    Socket.ReadLine(SockNum)
    IF Socket.Transferred  < 0 THEN
      SockNum = 0
      Etat = 0
      MessageBox("Le Serveur Cindy est Dconnect !!", "Socket Error !!", 0)
      Cindy_Socket.Clear
      Message_Socket.Clear
      Reconnect
      Etat_Label.Caption = "Dconnect du Systme..."
      Etat_Label.Left = 310
    END IF
  END IF
  Timer1.Enabled = True
END SUB

Timer_X.Interval = DELAY
Timer_X.OnTimer = Serveur_Starting
NumClients = 0
MasterSocket = Le_Socket.Open(PortNum)

IF MasterSocket = -1 THEN
  MessageBox("Impossible de Dmarrer : Port 80 (HTTP) Occup !!", "Socket Error !!", 0)
  END
END IF

SUB SwapClients(N AS INTEGER)
  DIM I AS INTEGER
  FOR I = N TO NumClients
    Client(I) = Client(I+1)
  NEXT
END SUB

SUB SendToClients (Message AS STRING)
  DIM I AS INTEGER
  DIM N AS INTEGER
  FOR I = 1 TO NumClients
    N = Le_Socket.WriteLine(Client(I), Message)
  NEXT
END SUB

SUB Serveur_Starting
  DIM I AS INTEGER
  DIM S AS STRING
  Timer_X.Enabled = False
  Timer_X.Interval = DELAY 
  IF Le_Socket.ConnectionReady(MasterSocket) > 0 THEN
    NumClients = NumClients + 1
    Client(NumClients) = Le_Socket.Accept(MasterSocket)
  END IF
  FOR I = 1 TO NumClients 
    IF Le_Socket.IsClientReady(MasterSocket, Client(I)) > 0 THEN
      S = Le_Socket.ReadLine(Client(I))
      Cindy_Socket.AddString "Cindy> " + S
      IF Le_Socket.Transferred = -1 THEN
         NumClients = NumClients - 1
         SwapClients(I)
      END IF
    END IF
  NEXT
  Timer_X.Enabled = True
END SUB

IF Etat = 0 THEN
    Timer1.Enabled = False
    Socket.Close(SockNum)
    SockNum = 0
    Timer1.Enabled = True
END IF
SockNum = Socket.Connect("127.0.0.1", 35)
IF SockNum > 0 THEN
    Etat = 1
    Main_Form.ShowModal
ELSE
    SockNum = 0
    MessageBox("Impossible de se Connecter  Cindy !!", "Socket Error !!", 0)
END IF
