﻿# -*-coding:UTF-8-*-
##########################
#Bot Kernel Code Computer#
##########################
###############################
#Système d'analyse des Phrases#
##################################
# - Phrase Verbale & Non Verbale #
# - Type de Phrase		 #
# - Forme de Phrase		 #
# - Type de Proposition		 #
# - Ponctuation			 #
##################################

from Systeme_Expert_Verbes import *

###################################
#Partie 0 : Analyse Phrase Verbale#
###################################

def Test_Mot_Existe(Phrase):
    Phrase = Phrase.lower()
    BDD_Error_No = [",",";",":","!","?",".","/","§","%","µ","£","^","$","¤","*","+", "&", "=", "#"]
    i = 0
    while i < len(BDD_Error_No):
        Phrase = Phrase.replace(BDD_Error_No[i], '')
        i += 1
    Mot_Recherche = Phrase.split()
    j = 0
    while j < len(Mot_Recherche):
        File = Mot_Recherche[j]
        try:
            f= open("../BDD/Linguistique/Dictionnaire/Mots_FR/"+File[0].upper()+".txt", "r")
            Analyse = f.readlines()
            f.close
            i = 0
            while i < len(Analyse):
                if Mot_Recherche[j]+'\n' == Analyse[i]:
                    return 'True'
                i += 1
        except:
            return 'Error'
        j += 1
    return 'False'

def Test_Verbe_Presence(Phrase):
    Phrase = Phrase.lower()
    Phrase = Phrase.split()
    i = 0
    while i < len(Phrase):
        if Conjug_On_The_Fly(Phrase[i]) != 0:
            return 'True'
        i += 1
    return 'False'

def Sujet_Analyse(Phrase):
    Phrase = Phrase.lower()
    Phrase = Phrase.split()
    BDD_Determinant = ['un', 'une', 'le', 'la', 'les', 'des', 'ces', 'ce', 'cet', 'cette']
    i = 0
    while i < len(Phrase):
        j = 0
        while j < len(BDD_Determinant):
            if BDD_Determinant[j] == Phrase[i]:
                return "%s %s" %(Phrase[i], Phrase[i+1])
            j += 1
        i += 1
    return 'False'

###################################
#Partie 1 : Analyse Type de Phrase#
###################################

def Ordre_Analyse(Phrase):
    Phrase = Phrase.lower()
    Phrase = Phrase.split()
    Flou_Var = 0
    if Conjug_On_The_Fly(Phrase[0]) != 0:
	return 'True'
    if Phrase[len(Phrase)-1] == '!':
        Flou_Var += 33.3
    i = 0
    while i < len(Phrase):
        if Conjug_On_The_Fly(Phrase[i]) != 0:
	    Flou_Var += 33.3
        i += 1
    if Pronom_Analyse(Phrase[0])[0] == 'True':
        Flou_Var += 33.3
    if Flou_Var >= 33.3*2.0:
        return 'True'
    return 'False'

print Ordre_Analyse("je le ferais pas !!")
raw_input('')